package com.jeesharp.business.modules.mall.controller;

import com.jeesharp.business.modules.mall.application.MallAddPurchaseApplicationService;
import com.jeesharp.business.modules.mall.dto.MallAddPurchaseSaveDTO;
import com.jeesharp.business.modules.mall.vo.MallAddPurchaseInfoVO;
import com.jeesharp.business.modules.mall.vo.MallAddPurchaseListVO;
import com.jeesharp.business.modules.mall.vo.MallAddPurchaseQueryVO;
import com.jeesharp.framework.pojo.AjaxResult;
import com.jeesharp.framework.pojo.Page;
import com.jeesharp.framework.pojo.query.PageRespVO;
import com.jeesharp.framework.web.controller.BaseController;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import lombok.AllArgsConstructor;
import org.springframework.web.bind.annotation.*;

import jakarta.validation.Valid;

/**
 * 加价购配置管理 Controller
 */
@RestController
@RequestMapping(value = "${jeesharp.web.adminPath}/manager/business/mall/addPurchase/v1")
@Tag(name = "加价购配置管理")
@AllArgsConstructor
public class MallAddPurchaseController extends BaseController {

    private final MallAddPurchaseApplicationService mallAddPurchaseApplicationService;

    @Operation(summary = "获取详情")
    @GetMapping(value = "info")
    public AjaxResult<MallAddPurchaseInfoVO> info(@RequestParam("id") String id) {
        MallAddPurchaseInfoVO vo = mallAddPurchaseApplicationService.get(id);
        return AjaxResult.okData(vo);
    }

    @Operation(summary = "获取列表（分页）")
    @PostMapping(value = "list")
    public AjaxResult<PageRespVO<MallAddPurchaseListVO>> list(@RequestBody MallAddPurchaseQueryVO query) {
        PageRespVO<MallAddPurchaseListVO> page = mallAddPurchaseApplicationService.findPage(new Page<>(query), query);
        return AjaxResult.okData(page);
    }

    @Operation(summary = "保存")
    @PostMapping(value = "save")
    public AjaxResult<Void> save(@RequestBody @Valid MallAddPurchaseSaveDTO dto) {
        mallAddPurchaseApplicationService.save(dto);
        return AjaxResult.ok("保存成功");
    }

    @Operation(summary = "删除")
    @GetMapping(value = "delete")
    public AjaxResult<Void> delete(@RequestParam("ids") String ids) {
        mallAddPurchaseApplicationService.delete(ids);
        return AjaxResult.ok("删除成功");
    }
}
